// Developed By Mhafy1016
import { world, system } from '@minecraft/server';
let shanks = [
    'hunger:grass', // Increase speed in grass block
    'hunger:villager', // Spawns golem every 2 mins
    'hunger:water', // (R-Click while holding water bucket)Frost Breath which can slow mobs.
    'hunger:wither_skeleton', // Gives Wither when you attack
    'hunger:lava', //(R Click while holding a lava bucket)Lava Breath that burns mobs
    'hunger:creeper', //(R-Click while holding gunpowder)explodes
    'hunger:gold', //Enemies drop golden items on being attacked with Gold Ingot
    'hunger:enderman', //(R-Click while holding EnderPearl)Go into Spectator mode for a bit. Warp using Enderpearl infinite times
    'hunger:diamond', //Enemies drop diamond items on being attacked with Diamond
    'hunger:dragon' //Can shoot a Fireball

], nutrition_values = {
    'cookie': 2,
    'beef': 3,
    'cooked_beef': 8,
    'porkchop': 3,
    'cooked_porkchop': 8,
    'chicken': 2,
    'cooked_chicken': 6,
    'apple': 4,
    'potato': 1,
    'carrot': 5,
    'cod': 2,
    'cooked_cod': 5,
    'salmon': 2,
    'cooked_salmon': 6,
    'tropical_fish': 2,
    'rabbit': 3,
    'cooked_rabbit': 5,
    'beetroot': 1,
    'beetroot_soup': 6,
    'mushroom_stew': 6,
    'rabbit_stew': 10,
    'melon_slice': 2,
    'pumpkin_pie': 8,
    'golden_apple': 4,
    'enchanted_golden_apple': 4,
    'spider_eye': 2,
    'golden_carrot': 6,
    'rotten_flesh': 4,
    'mutton': 2,
    'cooked_mutton': 6,
    'chorus_fruit': 4,
    'dried_kelp': 1,
};

world.afterEvents.itemCompleteUse.subscribe(e => {
    if (!e.itemStack) return;
    let nutrition = nutrition_values[e.itemStack.typeId.split(':')[1]] || 2;
    e.source.runCommandAsync(`effect @s[scores={hungerDiff=!0,hunger=1..}] hunger 3 255 true`);
    e.source.runCommandAsync(`scoreboard players add @s[scores={hunger=1..}] current_hunger ${nutrition}`);
});

world.afterEvents.itemUse.subscribe(e => {
    if (!e.itemStack) return;
    if (e.source.hasTag('hunger:creeper')) {
        if (e.itemStack.typeId.endsWith('gunpowder')) e.source.triggerEvent('hunger:explode');
    }
    if (e.source.hasTag('hunger:enderman')) {
        if (e.itemStack.typeId.endsWith('ender_pearl')) e.source.runCommandAsync(`give @s ender_pearl`);
    }
});

world.afterEvents.entityHitEntity.subscribe(e => {
    if (!e.damagingEntity) return;
    if (!e.damagingEntity.hasTag('hunger:wither_skeleton')) return;
    e.hitEntity.runCommandAsync(`effect @s wither 10 2`);
});

world.beforeEvents.itemUse.subscribe(e => {
    if (!e.itemStack) return;
    if (e.source.hasTag('hunger:enderman')) {
        if (e.source.isSneaking && e.itemStack.typeId.endsWith('ender_pearl')) {
            e.cancel = true;
            e.source.runCommandAsync(`scoreboard players set @a spectator_mode 300`);
        }
    }
    if (e.source.hasTag('hunger:dragon')) {
        if (!e.source.isSneaking) return;
        if (e.itemStack.typeId.endsWith('gunpowder')) return;
        if (e.itemStack.typeId.endsWith('ender_pearl')) return;
        if (e.itemStack.typeId.endsWith('lava_bucket')) return;
        if (e.itemStack.typeId.endsWith('water_bucket')) return;
        e.cancel = true;
        e.source.runCommandAsync(`event entity @s hunger:fireball`);
    }
    if (e.source.hasTag('hunger:lava')) {
        if (e.source.isSneaking && e.itemStack.typeId.endsWith('lava_bucket')) {
            e.cancel = true;
            e.source.runCommandAsync(`event entity @s hunger:shoot_fire`);
        }
    }
    if (e.source.hasTag('hunger:water')) {
        if (e.source.isSneaking && e.itemStack.typeId.endsWith('water_bucket')) {
            e.cancel = true;
            e.source.runCommandAsync(`event entity @s hunger:shoot_frost`);
        }
    }
});

world.beforeEvents.itemUseOn.subscribe(e => {
    if (!e.itemStack) return;
    if (e.source.hasTag('hunger:dragon')) {
        if (!e.source.isSneaking) return;
        if (e.itemStack.typeId.endsWith('gunpowder')) return;
        if (e.itemStack.typeId.endsWith('ender_pearl')) return;
        if (e.itemStack.typeId.endsWith('lava_bucket')) return;
        if (e.itemStack.typeId.endsWith('water_bucket')) return;
        e.cancel = true;
        e.source.runCommandAsync(`event entity @s hunger:fireball`);
    }
    if (e.source.hasTag('hunger:lava')) {
        if (e.source.isSneaking && e.itemStack.typeId.endsWith('lava_bucket')) {
            e.cancel = true;
            e.source.runCommandAsync(`event entity @s hunger:shoot_fire`);
        }
    }
    if (e.source.hasTag('hunger:water')) {
        if (e.source.isSneaking && e.itemStack.typeId.endsWith('water_bucket')) {
            e.cancel = true;
            e.source.runCommandAsync(`event entity @s hunger:shoot_frost`);
        }
    }
});

world.afterEvents.entityDie.subscribe(e => {
    if (!e.damageSource) return;
    if (!e.damageSource.damagingEntity) return;
    if (!e.damageSource.damagingEntity.typeId.endsWith('player')) return;
    let player = e.damageSource.damagingEntity;
    if (player.hasTag('hunger:diamond')) e.deadEntity.runCommandAsync('loot spawn ~~1~ loot diamondLoots');
    if (player.hasTag('hunger:gold')) e.deadEntity.runCommandAsync('loot spawn ~~1~ loot goldenLoots');
});

(function tick() {
    try {
        for (let player of world.getAllPlayers()) {
            let s = '', index = 0;
            for (let tag of player.getTags()) {
                if (!shanks.includes(tag)) continue;
                let n = [`3${shanks.indexOf(tag)}`, `4${shanks.indexOf(tag)}`, '09'][Math.floor(Math.max(Math.min((index++ + 1) * 2 - getHunger(player), 2), 0))];
                s = `${String.fromCharCode(parseInt(`e1${n}`, 16))}` + s;
            }
            if (s == '') s = String.fromCharCode(parseInt(`e10a`, 16));
            if (!player.hasTag('spectating')) player.runCommandAsync(`title @s actionbar ${s}`);
            else player.runCommandAsync(`title @s actionbar ${String.fromCharCode(parseInt(`e10a`, 16))}`);
        }
        system.runTimeout(tick, 1);
    } catch (err) { throw err; }
})();
function getHunger(ent) {
    for (let t of ent.getTags()) {
        if (t.startsWith('hunger_')) return parseFloat(t.split('_')[1]);
    }
    return 0;
}
function setHunger(ent, n) {
    for (let t of ent.getTags()) {
        if (t.startsWith('hunger_')) ent.removeTag(t);
    }
    ent.addTag(`hunger_${n.toFixed(2)}`);
}